﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using CPRogPluginFramework;

namespace LibPlugin
{
   

    public class TestPlugin : ICPRogPluginCmd
    {
        int cnt = 0;

        //****************************************************************
        // Der hier zurückgegebene Wert muss mit dem im Plugin-Kommando des
        // Roboterprogramms in CProg übereinstimmen.
        public string PluginName { get { return "PluginExample"; } }
        public int PluginInterfaceVersion { get { return 1; } }

        //****************************************************************
        // Ist die übergebene Position eine Joint-Position oder eine cartesische Position
        // (bisher werden von CProg nur cartesische Positionen unterstützt)
        public bool MotionTypeJoints 
        {
            get
            {
                return false;
            }
        }

        public void GetPluginDescription(ref string Version, ref string DescriptionShort, ref string Description)
        {
            Version = "0.0.1";
            DescriptionShort = "DLL based test plugin";
            Description = "Here a longer description can be given";
        }
        public void GetPluginManufacturer(ref string Company, ref string website, ref string supportMail)
        {
            Company = "Test LLC";
            website = "www.testllc.com";
            supportMail = "support@testllc.com";
        }

        public int Initialize()
        {
            return 0;
        }

        //****************************************************************
        // An dieser Stelle kann das Plugin einen eigenen Dialog zur konfiguartion anzeigen
        public void ShowGUI()
        {
            ;
        }

        //****************************************************************
        public string LogMessage() {
            string msg = "TestMessage " + cnt;
            return msg;
        }

        //****************************************************************
        // Provides information on the status of the robot
        public int UpdatePosition(robotStatus robState, TimeSpan diffTime, double ovr, ref double[] joints, ref float[] positionMatrix, ref double[] orientationEuler, bool[] digitalIn, ref bool[] digitalOut)
        {
           
                return 0;       
        }

        //****************************************************************
        // return value: 
        // 1 = correct position is available  0 = no object recognized
        // camNr: which camera to get the target position from
        // posCart und oriEuler: Return values with the target position
        // posCart and oriEuler are initialized with the current robots values, so only changes need to be filled
        public int GetTargetPosition(int camNr, ref int resClass, ref float[] posCart, ref float[] oriEuler)
        {
            resClass = 3;
            posCart[0] = 300.0f;
            posCart[1] = 50.0f;
            posCart[2] = 200.0f;

            return 1;
        }

        //****************************************************************
        // provides the path of the plugin directory where the plugin can find ini files etc
        public void SetPluginDirectoryPath(string path)
        {
        }
    }
}
